package com.csc.library.jwt;

import java.io.UnsupportedEncodingException;
import java.util.Date;
import java.util.HashMap;
import java.util.Map;

import com.auth0.jwt.JWT;
import com.auth0.jwt.JWTVerifier;
import com.auth0.jwt.algorithms.Algorithm;
import com.auth0.jwt.exceptions.JWTCreationException;
import com.auth0.jwt.interfaces.DecodedJWT;

public class TestJwt {

	public static void main(String[] args) throws IllegalArgumentException, UnsupportedEncodingException {
		String secret = "zeeme.csc-secret";
		String issuer = "Computer Science Corporation Limited";
		String subject = "zeeme.csc";
		try {
			long st1 = System.currentTimeMillis();
			Map<String,Object> header = new HashMap<String,Object>();
			header.put("type", "JWT");
			header.put("alg", "HS256");
			header.put("test", "test");
 			Algorithm alg = Algorithm.HMAC256(secret);
			long st2 = System.currentTimeMillis();
			System.out.println("pre data step : st : "+st2+" st1 : "+st1 +" ==  "+(st2-st1));
		    String token = JWT.create()
		    	.withSubject(subject)
//		    	.withHeader(header)
		        .withIssuer(issuer)
		        .withClaim("test claim", "test claim")
		        //.withExpiresAt(new Date())
		        .sign(alg);
		    long st3 = System.currentTimeMillis();
		    System.out.println("sign step : st2 : "+st2+" st3 : "+st3 +" ==  "+(st3-st2));
		    System.out.println(token);
//		    try {
//				Thread.sleep(3000);
//			} catch (InterruptedException e) {
//				e.printStackTrace();
//			}
		    
		    System.out.println(JWT.decode(token).getClaims());
		    long st4 = System.currentTimeMillis();
		    System.out.println("decode step : st3 : "+st3+" st4 : "+st4 +" ==  "+(st4-st3));
		    JWTVerifier verifier = JWT.require(alg)
		    		//.acceptExpiresAt(1000)
		    		.withSubject(subject)
		            .withIssuer(issuer)
		            .build(); //Reusable verifier instance
		    DecodedJWT jwt = verifier.verify(token);
		    System.out.println(jwt.getSubject());
		    System.out.println(jwt.getHeaderClaim("type").asString());
		    long st5 = System.currentTimeMillis();
		    System.out.println("verify step : st4 : "+st4+" st5 : "+st5 +" ==  "+(st5-st4));
		    
		} catch (JWTCreationException exception){
		    //Invalid Signing configuration / Couldn't convert Claims.
		}
	}

}
